package assignment1;

import java.io.*;
import java.util.HashSet;
import java.util.StringTokenizer;

import com.hp.hpl.jena.query.Query;
import com.hp.hpl.jena.query.QueryExecution;
import com.hp.hpl.jena.query.QueryExecutionFactory;
import com.hp.hpl.jena.query.QueryFactory;
import com.hp.hpl.jena.query.QuerySolution;
import com.hp.hpl.jena.query.ResultSet;
import com.hp.hpl.jena.rdf.model.InfModel;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.reasoner.Reasoner;
import com.hp.hpl.jena.reasoner.ReasonerRegistry;
import com.hp.hpl.jena.util.FileManager;

public class Test{
	
	static String nsgs = "<http://www.semanticweb.org/ontologies/2010/1/Ontology1266620593961.owl#>";
	static String nsdblp = "<http://www.semanticweb.org/ontologies/2010/1/dblp.owl#>";
	
	static String nsgs1 = "http://www.semanticweb.org/ontologies/2010/1/Ontology1266620593961.owl#";
	static String nsdblp1 = "http://www.semanticweb.org/ontologies/2010/1/dblp.owl#";
	
	Model scholars=null;
	Model schemas=null;
	InfModel allCoAuthors = null;
	
	
private void loadMergeandALign() throws IOException
{
	scholars = ModelFactory.createOntologyModel();
	//InputStream ings =  new Buffer("googlescholar.owl");
	InputStream ings = FileManager.get().open("googlescholar.owl");
	scholars.read(ings, "");
	String str = "PREFIX owlgs:"+ nsgs +
	 		      "select ?name where{ ?name owlgs:coAuthoredWith ?nextname } ";
	 
	InputStream indblp = FileManager.get().open("C:/Users/Charu/Desktop/dblp.owl");
	//InputStream indblp = new BufferedInputStream(this.getClass().getResourceAsStream("dblp.owl"));
	
	scholars.read(indblp, nsdblp1);
	schemas = ModelFactory.createOntologyModel();
	InputStream ingsschema = FileManager.get().open("C:/Users/Charu/Desktop/googlescholarschema.owl");	
	schemas.read(ingsschema,nsgs1);
	InputStream ingsschema1 = FileManager.get().open("C:/Users/Charu/Desktop/googlescholarschema.owl");
	scholars.read(ingsschema1,nsgs1);
	
	InputStream indblpschema = FileManager.get().open("C:/Users/Charu/Desktop/dblpschema.owl");
	scholars.read(indblpschema, nsdblp1);
	
	ingsschema.close();
	ingsschema1.close();
	indblpschema.close();
	
	//Aligning ontology
	Resource resource = schemas.createResource(nsgs + "Title");
	Property prop = schemas.createProperty("http://www.w3.org/2002/07/owl#equivalentClass");
	Resource obj = schemas.createResource(nsdblp+ "Publication");
	schemas.add(resource,prop,obj);
	
	resource = schemas.createResource(nsgs + "Author");
	prop = schemas.createProperty("http://www.w3.org/2002/07/owl#equivalentClass");
	obj = schemas.createResource(nsdblp+ "Name");
	schemas.add(resource,prop,obj);
	
	
	resource = schemas.createResource(nsgs + "coAuthoredWith");
	prop = schemas.createProperty("http://www.w3.org/2002/07/owl#equivalentProperty");
	obj = schemas.createResource(nsdblp +"hasCoAuthor");
	schemas.add(resource,prop,obj);

	resource = schemas.createResource(nsgs + "Amit_P_Sheth");
	prop = schemas.createProperty("http://www.w3.org/2002/07/owl#sameAs");
	obj = schemas.createResource(nsdblp+"Amith_Sheth");
	schemas.add(resource,prop,obj);	
	//End of aligning ontology
	
	Reasoner reasoner = ReasonerRegistry.getOWLReasoner();
    reasoner = reasoner.bindSchema(schemas);
    allCoAuthors = ModelFactory.createInfModel(reasoner, scholars);

    str ="PREFIX owlgs:" + nsgs + " PREFIX owldblp:" + nsdblp +
    	"SELECT DISTINCT ?coauthors where{owldblp:Amith_Sheth owldblp:hasCoAuthor ?coauthors }";
    
		Query q = QueryFactory.create(str.toString());
		QueryExecution qe = QueryExecutionFactory.create(q, allCoAuthors);
		try {
		ResultSet rs = qe.execSelect();
		
		while( rs.hasNext()){
			QuerySolution soln = rs.nextSolution();
			RDFNode coauth = soln.get("?coauthors");
			if( coauth != null ){
				String temp = coauth.toString();
				StringTokenizer strtok = new StringTokenizer(temp, "#");
				String coauthname = strtok.nextToken();
				coauthname = strtok.nextToken();
				System.out.println( coauthname + " is a co-author" );
			}
			else
				System.out.println("End of records");
			}
		} finally { qe.close();}	
	 
	 
}
	public static void main(String args[])
	{	
		Test smallproj = new Test();
		try {
			smallproj.loadMergeandALign();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
}